/* 
 Joan Soler-Adillon
 Realitat Virtual || Realidad Virtual - Processing
 Màster en Arts Digitals, UPF
 http://www.joan.cat/
 */


float gravedad, valorDeFriccionY, valorDeFriccionX;
int ballsSize = 15;
//cremos ARRAYLIST para guardar las bolas
//sin necesidad de decidir a priori su número
ArrayList bolas = new ArrayList();



void setup() {
  size(800,600);
  //gravedad. De hecho, es un valor de aceleración.
  gravedad = 0.1;
  //y finalmente, un valor de fricción, para ir desacelerando la bola a medida que  va tocando el suelo. 
  //Es el valor por el que multiplicaremos la velocidad de la misma.
  valorDeFriccionY = -0.8;
  valorDeFriccionX = -0.8;

  noStroke();
  fill(255,0,0);
}


void draw() {

  background(0);

  actualizarCursor();
  actualizarBolas();
}

void actualizarCursor() {

  //////CURSOR  //si clicamos
  if(mousePressed) {
    //cambia el cursos
    cursor(HAND);
    //y dibuja una elipse donde está este, para dar la impresión que se creó una y el usuario la tiene 
    ellipse(mouseX,mouseY,ballsSize,ballsSize);
  } 
  else {
    cursor(ARROW);
  }
  //
}

void actualizarBolas() {
  for(int i=0;i<bolas.size();i++) {
    ball b = (ball) bolas.get(i);
    b.run();
  }
}

//al dejar el mouse
void mouseReleased() {
  //creamos una nueva bola
  ball b = new ball(); 
  //y la añadimos al Array
  bolas.add(b);
}

//si clicamos una tecla
void keyPressed() {
  //si es ESPACIO, disparamos la bolas para arriba
  if (key==' ') {
    for(int i = 0; i<bolas.size(); i++) {
      ball b = (ball) bolas.get(i);  
      b.myV.x = random(-5,5);
      b.myV.y = random(-8,-0.5);
    }
  } //Si es la C, cambiamos el modo de color
  else if (key=='r') {
    bolas.clear();
  }
}

////////////////////////////////////////////////////////
///////////////// CLASS BOLAS

class ball {

  PVector myP, myV; 
  int mySz = 15;

  ball() {
    myP = new PVector(mouseX,mouseY);
    myV = new PVector(mouseX-pmouseX,mouseY-pmouseY);
  } 

  void run() {
    update();
    drawMe();
  }

  void update() {
    myV.y += gravedad;

    //actualitzamos las posiciones
    myP.x += myV.x;
    myP.y += myV.y;

    //comprobamos los bordes X
    if(myP.x<mySz/2) {
      myV.x *= valorDeFriccionX;
      myP.x = mySz/2;
    } 
    else if (myP.x>width-mySz/2) {
      myV.x *= valorDeFriccionX;
      myP.x = width-mySz/2;
    }

    //comprobamos los bordes sólo por abajo. 
    if (myP.y>height-mySz/2) {
      myV.y *= valorDeFriccionY;
      //para que no se enganche:
      myP.y = height-mySz/2;
    }
  }

  void drawMe() {
    noStroke();
    fill(255,0,0);
    ellipse(myP.x,myP.y,mySz,mySz);
  }
}

