class snake{
  //Diámetro de la cabeza
  int myHeadSize;
  //Diámetro de la cola
  int myTailSize;
  //Largo inicial de la cola
  int myTailLength;
  //variables para dirección del bicho
  int myXDirection = 1;
  int myYDirection = 0;
  //velocidad
  int mySpeed;
  int bordes;
  //int myXOriginalPosition = 100;
  //int myYOriginalPosition = height/2;
  PVector myInitialPosition = new PVector(100,height/2);
  ArrayList myPositions = new ArrayList();
  //ArrayList myYPositions = new ArrayList();
  boolean dead = false;

  //constructor
  snake(int _hs, int _ts, int _tl, int _s, int _ipX, int _ipY){
    //asignamos variables temporales a las de la clase
    myHeadSize = _hs;
    myTailSize = _ts;
    myTailLength = _tl;
    mySpeed = _s;
    myInitialPosition.x = _ipX;
    myInitialPosition.y = _ipY;
    bordes = _ipX;
    //añadimos la posicion inical al array de posiciones
    myPositions.add(myInitialPosition);

    //iniciamilizamos todos los vectores de posición de la serpiente (cabeza y los de cola) a esta posicion original
    for(int i=1; i<tailLength; i++){
      myPositions.add(new PVector(myInitialPosition.x,myInitialPosition.y));
    }

  } 

  //actualizamos
  void update(){
    if(!dead){//si la serpiente está viva
      savePositions();//guardamos posiciones actuales para la cola
      move();//generamos nueva posicion
      checkBorders();//Comprobamos la ventana
      drawMe();//dibujamos
    } 
    else {//si la serpiente murió
      background(255,0,0);
    }
  }

  void savePositions(){
    //println(myPositions.size());
    //asignamos a cada punto de la cola el que tiene el punto inmediatamente anterior
    for(int i=myPositions.size()-1; i>0; i--){
      //"cargamos" las posiciones
      PVector v2 = (PVector) myPositions.get(i);
      PVector v1 = (PVector) myPositions.get(i-1);
      //asignamos Xs e Ys
      v2.x=v1.x;
      v2.y=v1.y;
      //y cambiamos el vector en el array de posiciones al nuevo
      myPositions.set(i,v2);
    }
    //println("");
  }

  void move(){
    //movimiento: 
    //"cargamos la posición 0: la cabeza
    PVector myPos = (PVector) myPositions.get(0);
    //le añadimos la velovidad y dirección
    myPos.x += mySpeed*myXDirection;
    myPos.y += mySpeed*myYDirection;
    //comprobamos si la posición es correcta (en términos del juego)
    checkNewPosition(myPos);
    //y guardamos la posición de la cabeza en el array
    myPositions.set(0, myPos);
  }

  void drawMe(){
    //cargamos el vector de la cabeza...
    PVector myPos = (PVector) myPositions.get(0);
    //... y dibujamos la elipse de la cabeza
    ellipse(myPos.x,myPos.y,myHeadSize,myHeadSize);
    //Luego, hacemos lo propio con la cola:
    for(int i=1; i<myPositions.size(); i++){
      PVector v = (PVector) myPositions.get(i);
      ellipse(v.x,v.y,myTailSize,myTailSize);
    }   
  }

  //comprobamos los bordes respecto a la cabeza
  void checkBorders(){
    PVector v = (PVector) myPositions.get(0);
    if(v.x < bordes || v.x > width-bordes)die();//se pasó en la x: Muerte!
    if(v.y < bordes || v.y > height-bordes)die();//se pasó en la y: Muerte!
  }

  void checkNewPosition(PVector _v){
    //Comprobar si en la posición hay comida, con lo que habrá que CRECER
    //_v es el vector de posición de la cabeza
    boolean theresFoodInThisPosition = false;//creamos variable como que no es comida
    int indexOfFood = -1; //(es por si hay más de un elemento comida en activo)
    for(int i=0; i<foodArray.size(); i++){//iteramos en el array de comida
      food f = (food) foodArray.get(i);//cargamos el elemento de comida en cuestión
      //Aquí UTILIZAMOS UNA FUNCIÓN QUE SE COMUNICA DIRECTAMENTE CON EL OBJETO "COMIDA" para pedirle su posición
      PVector vv = f.getPosition();
      if(vv.x==_v.x && vv.y==_v.y){//si la posición de la comida es la misma que la de la cabeza
        theresFoodInThisPosition=true;//sí! hay comida
        indexOfFood = i; //(es por si hay más de un elemento comida en activo)
      }
    }
    if(theresFoodInThisPosition)eatAndGrow(indexOfFood);

    //Comprobar si en la posición ya hay serpiente, con lo que habrá que morir!
    boolean positionIsOccupied = false;  
    for(int i=1; i<myPositions.size(); i++){
      PVector v = (PVector) myPositions.get(i);
      if(v.x==_v.x && v.y==_v.y)positionIsOccupied=true;
    }
    if(positionIsOccupied)die();
  }

  void eatAndGrow(int _f){//comida y crecimiento
    //eliminamos la comida de foodArray (es por si hay más de una en activo)
    foodArray.remove(_f);
    //y añadimos una posición en la cola
    myPositions.add(new PVector(-100,-100));
  }

  void die(){//la muerte
    background(255,127,127);
    dead = true;
  }

  void setDirection(int _d){//cambia de dirección (con las flechas)

    switch(_d) {
    case 1: 
      if(myXDirection!=0 && myYDirection!=1){
        myXDirection = 0;
        myYDirection = -1;
      }
      break;
    case 2: 
      if(myXDirection!=0 && myYDirection!=-1){
        myXDirection = 0;
        myYDirection = 1;
      }
      break;  
    case 3: 
      if(myXDirection!=1 && myYDirection!=0){
        myXDirection = -1;
        myYDirection = 0;
      }
      break;
    case 4: 
      if(myXDirection!=-1 && myYDirection!=0){
        myXDirection = 1;
        myYDirection = 0;
      }
      break;
    default:    
      break;
    }
  }


}









